aboutsummaryrefslogtreecommitdiffstats
path: root/recipes/busybox
diff options
context:
space:
mode:
authorPhil Blundell <philb@gnu.org>2009-06-17 12:12:41 +0100
committerPhil Blundell <philb@gnu.org>2009-06-17 12:12:41 +0100
commit369231aee815fd14a4a5719f3adfb4557774c35a (patch)
treec0d7496fdd26cd961f407d3e63e9a1c020b80e6b /recipes/busybox
parent77bf7d8f008775376cfbaacb05ef62afd386703b (diff)
downloadopenembedded-369231aee815fd14a4a5719f3adfb4557774c35a.tar.gz
busybox: make udhcpc script work in absence of legacy net-tools
Diffstat (limited to 'recipes/busybox')
-rw-r--r--recipes/busybox/busybox.inc6
-rw-r--r--recipes/busybox/files/simple.script72
2 files changed, 75 insertions, 3 deletions
diff --git a/recipes/busybox/busybox.inc b/recipes/busybox/busybox.inc
index 7b9b92940f..0ff65a41bc 100644
--- a/recipes/busybox/busybox.inc
+++ b/recipes/busybox/busybox.inc
@@ -11,14 +11,14 @@ LICENSE = "GPL"
SECTION = "base"
PRIORITY = "required"
-INC_PR = "r21"
+INC_PR = "r22"
SRC_URI = "\
http://www.busybox.net/downloads/busybox-${PV}.tar.gz \
file://busybox-cron \
file://busybox-httpd \
file://busybox-udhcpd \
- file://default.script \
+ file://default.script file://simple.script \
file://dhcp-hostname.patch;patch=1 \
file://hwclock.sh \
file://ifupdown-spurious-environ.patch;patch=1 \
@@ -120,7 +120,7 @@ do_install () {
if grep "CONFIG_APP_UDHCPC=y" ${WORKDIR}/defconfig; then
install -d ${D}${sysconfdir}/udhcpc.d
install -d ${D}${datadir}/udhcpc
- install -m 0755 ${S}/examples/udhcp/simple.script ${D}${sysconfdir}/udhcpc.d/50default
+ install -m 0755 ${WORKDIR}/simple.script ${D}${sysconfdir}/udhcpc.d/50default
install -m 0755 ${WORKDIR}/default.script ${D}${datadir}/udhcpc/default.script
fi
if grep "CONFIG_FEATURE_MOUNT_FSTAB=y" ${WORKDIR}/defconfig; then
diff --git a/recipes/busybox/files/simple.script b/recipes/busybox/files/simple.script
new file mode 100644
index 0000000000..5cc21b9de2
--- /dev/null
+++ b/recipes/busybox/files/simple.script
@@ -0,0 +1,72 @@
+#!/bin/sh
+
+# udhcpc script edited by Tim Riker <Tim@Rikers.org>
+
+[ -z "$1" ] && echo "Error: should be called from udhcpc" && exit 1
+
+RESOLV_CONF="/etc/resolv.conf"
+[ -n "$broadcast" ] && BROADCAST="broadcast $broadcast"
+[ -n "$subnet" ] && NETMASK="netmask $subnet"
+
+# return 0 if root is mounted on a network filesystem
+root_is_nfs() {
+ grep -qe '^/dev/root.*\(nfs\|smbfs\|ncp\|coda\) .*' /proc/mounts
+}
+
+have_bin_ip=0
+if [ -x /bin/ip ]; then
+ have_bin_ip=1
+fi
+
+case "$1" in
+ deconfig)
+ if ! root_is_nfs ; then
+ if [ $have_bin_ip -eq 1 ]; then
+ ip addr flush dev $interface
+ ip link set dev $interface up
+ else
+ /sbin/ifconfig $interface 0.0.0.0
+ fi
+ fi
+ ;;
+
+ renew|bound)
+ if [ $have_bin_ip -eq 1 ]; then
+ ip addr add dev $interface local $ip/$mask $BROADCAST
+ else
+ /sbin/ifconfig $interface $ip $BROADCAST $NETMASK
+ fi
+
+ if [ -n "$router" ] ; then
+ if ! root_is_nfs ; then
+ if [ $have_bin_ip -eq 1 ]; then
+ while ip route del default 2>/dev/null ; do
+ :
+ done
+ else
+ while route del default gw 0.0.0.0 dev $interface 2>/dev/null ; do
+ :
+ done
+ fi
+ fi
+
+ metric=0
+ for i in $router ; do
+ if [ $have_bin_ip -eq 1 ]; then
+ ip route add default via $i metric $((metric++))
+ else
+ route add default gw $i dev $interface metric $((metric++)) 2>/dev/null
+ fi
+ done
+ fi
+
+ echo -n > $RESOLV_CONF
+ [ -n "$domain" ] && echo search $domain >> $RESOLV_CONF
+ for i in $dns ; do
+ echo adding dns $i
+ echo nameserver $i >> $RESOLV_CONF
+ done
+ ;;
+esac
+
+exit 0